﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Threading; // threading
using System.Runtime.InteropServices; // for GetLasterror()

namespace WDMSample
{
    static class Constants
    {
        public const double Pi = 3.14159;
        public const int SpeedOfLight = 300000; // km per sec.

        public const int ERROR_SUCCESS = 0;
        public const int ERROR_INVALID_FUNCTION = 1;
        public const int ERROR_FILE_NOT_FOUND = 2;
        public const int ERROR_OPERATION_ABORTED = 995;
    }

    class IRQThread : ThreadClass
    {
        //TCOSData COSData[10];
        WDMSample.Form1.TCOSData[] CardData = new WDMSample.Form1.TCOSData[10];
        int LastError;
	    ulong COSPPIs;
        int CardNum;
	    //CCOSDlg* MainWnd;
	    //void SetOwner(CCOSDlg* pOwner) { MainWnd = pOwner; };
        
        private void IRQThreadProc() 
        {	
	        //if (MainWnd == NULL)
	          //return -1;

            //while (WaitForIRQType() != 0) ReportIRQ();
            LastError = Marshal.GetLastWin32Error();
            ReportError();
            //return CWinThread::Run();
        }

        private void ReportError()
        {
	        //CSingleLock sLock(&((CCOSDlg*)MainWnd)->m_mutex);
            //sLock.Lock();
            //if (LastError == ERROR_OPERATION_ABORTED)
                 //((CCOSDlg*)MainWnd)->AddLine(CardNum, "IRQ request aborted.");
            //else if (LastError == ERROR_INVALID_FUNCTION)
                 //((CCOSDlg*)MainWnd)->AddLine(CardNum, "Error: this card already has a pending IRQ request. IRQ request aborted.");
            //else
                 //((CCOSDlg*)MainWnd)->AddLine(CardNum, "Some error occurred in the driver. IRQ request aborted.");
            //sLock.Unlock();
        }
/*
        private void ReportIRQ()
        {      
	         CSingleLock sLock(&((CCOSDlg*)MainWnd)->m_mutex);
             sLock.Lock();
             if (COSPPIs == 0)
                 ((CCOSDlg*)MainWnd)->ReceiveGenIRQ(CardNum);
             else
                 ((CCOSDlg*)MainWnd)->ReceiveCOSData(CardNum, &COSData[0]);
             sLock.Unlock();
        }

        private ulong WaitForIRQType()
        {
	         if (COSPPIs != 0)
                 return (COSWaitForIRQ(CardNum, COSPPIs, &COSData[0]));
             else
                 return (WaitForIRQ(CardNum));
        }
*/
    }
}
